function [ upperb, lowerb ] = SimulateDecayHitting( startnode, endnodes, maxstep, rwnum, n)
%SIMULATEHITTING Summary of this function goes here
%   approximate decay hitting time by random walk simulations
%   need external variables: sumofRowW and nnzidx_cell
    global sumofRowW nnzidx_cell;
    
    upperb = 0;
    lowerb = 0;
    %judgestop = ismember(1:n,endnodes);
    judgestop = zeros(1,n);
    judgestop(endnodes) = 1;
    
    for i = 1 : rwnum
        step = 0;
        currentnode = startnode;

        % using isempty( find(endnodes == currentnode, 1) ) is time
        % consuming
        while ~judgestop(currentnode)
            if step >= maxstep
                break;
            end
            % select a neighbor of current node for random walk
            nextnodeidx = randi(sumofRowW(currentnode), 1);
            
            %jump to the new node
            step = step + 1;
            tempnd = nnzidx_cell{currentnode}(nextnodeidx);
            currentnode = tempnd;
        end
        if ~judgestop(currentnode)
            bsize = length(endnodes);
            if bsize < (sumofRowW(currentnode) -1)
                dm = bsize;
            else
                dm = sumofRowW(currentnode) -1;
            end
            ratio = dm / sumofRowW(currentnode);
            upperb = upperb + exp(-maxstep) * ratio + exp(-maxstep-1) * (1-ratio);
        else
            lowerb = lowerb + exp(1-step);
        end
    end
    upperb = (lowerb + upperb) / rwnum;
    lowerb = lowerb / rwnum;

end

